package nullfree.linkedlist.polymorph;

import nullfree.linkedlist.HeadAndTail;
import nullfree.linkedlist.Node;

class HeadNode<T> extends PolymorphNode<T> implements HeadOrMiddleNode<T> {
	private MiddleOrTailNode<T> next;
	protected HeadNode(T value) {
		super(value);
	}
	@Override
	public boolean hasNext() {
		return true;
	}
	@Override
	public boolean hasPrev() {
		return false;
	}
	@Override
	public Node<T> getNext() {
		return next;
	}
	@Override
	public Node<T> getPrev() {
		return this;
	}
	@Override
	public MiddleNode<T> insertValue(T value, HeadAndTail<T> ref) {
		MiddleNode<T> newnode = new MiddleNode<T>(value);
		link(this, newnode);
		link(newnode, next);
		return newnode;
	}
	@Override
	public void remove(HeadAndTail<T> ref) {
		setValue(next.getValue());
		link(this, (MiddleOrTailNode<T>)next.getNext());
	}
	//
	public void setNext(MiddleOrTailNode<T> next) {
		this.next = next;
	}
}
