package nullfree.linkedlist.polymorph;

import nullfree.linkedlist.HeadAndTail;
import nullfree.linkedlist.Node;

class MiddleNode<T> extends PolymorphNode<T> implements HeadOrMiddleNode<T>, MiddleOrTailNode<T>{
	private MiddleOrTailNode<T> next;
	private HeadOrMiddleNode<T> prev;
	protected MiddleNode(T value) {
		super(value);
	}
	@Override
	public boolean hasNext() {
		return true;
	}
	@Override
	public boolean hasPrev() {
		return true;
	}
	@Override
	public Node<T> getNext() {
		return next;
	}
	@Override
	public Node<T> getPrev() {
		return prev;
	}
	@Override
	public MiddleNode<T> insertValue(T value, HeadAndTail<T> ref) {
		MiddleNode<T> newnode = new MiddleNode<T>(value);
		link(this, newnode);
		link(newnode, next);
		link(prev, this);
		return newnode;
	}
	@Override
	public void remove(HeadAndTail<T> ref) {
		link(prev, next);
	}
	//
	public void setNext(MiddleOrTailNode<T> next) {
		this.next = next;
	}
	public void setPrev(HeadOrMiddleNode<T> prev) {
		this.prev = prev;
	}
}
