package nullfree.linkedlist.polymorph;

import nullfree.linkedlist.HeadAndTail;
import nullfree.linkedlist.Node;

abstract class PolymorphNode<T> implements Node<T> {
	private T value;
	protected PolymorphNode(T value) {
		this.value = value;
	}
	public abstract boolean hasNext();
	public abstract boolean hasPrev();
	public abstract Node<T> getNext();
	public abstract Node<T> getPrev();
	public T getValue() {
		return value;
	}
	public void setValue(T value) {
		this.value = value;
	}
	public abstract Node<T> insertValue(T value, HeadAndTail<T> ref);
	protected static <T> void link(HeadOrMiddleNode<T> n1, MiddleOrTailNode<T> n2) {
		n1.setNext(n2);
		n2.setPrev(n1);
	}
}
 
