package nullfree.linkedlist.polymorph;

import nullfree.linkedlist.HeadAndTail;
import nullfree.linkedlist.Node;

class SingleNode<T> extends PolymorphNode<T> {
	protected SingleNode(T value) {
		super(value);
	}
	@Override
	public boolean hasNext() {
		return false;
	}
	@Override
	public boolean hasPrev() {
		return false;
	}
	@Override
	public Node<T> getNext() {
		return this;
	}
	@Override
	public Node<T> getPrev() {
		return this;
	}
	@Override
	public TailNode<T> insertValue(T value, HeadAndTail<T> ref) {
		TailNode<T> newnode = new TailNode<T>(value);
		HeadNode<T> transformthis = new HeadNode<T>(getValue());
		link(transformthis, newnode);
		((SimpleHeadAndTail<T>)ref).setHead(transformthis);
		((SimpleHeadAndTail<T>)ref).setTail(newnode);
		return newnode;
	}
	@Override
	public void remove(HeadAndTail<T> ref) {
		throw new UnsupportedOperationException("Can not remove last node from a null free linked list");
	}
}
