package nullfree.linkedlist.polymorph;

import nullfree.linkedlist.HeadAndTail;
import nullfree.linkedlist.Node;

class TailNode<T> extends PolymorphNode<T> implements MiddleOrTailNode<T> {
	private HeadOrMiddleNode<T> prev;
	protected TailNode(T value) {
		super(value);
	}
	@Override
	public boolean hasNext() {
		return false;
	}
	@Override
	public boolean hasPrev() {
		return true;
	}
	@Override
	public Node<T> getNext() {
		return this;
	}
	@Override
	public Node<T> getPrev() {
		return prev;
	}
	@Override
	public TailNode<T> insertValue(T value, HeadAndTail<T> ref) {
		TailNode<T> newnode = new TailNode<T>(value);
		MiddleNode<T> transformthis = new MiddleNode<T>(getValue());
		link(transformthis, newnode);
		link(prev, transformthis);
		((SimpleHeadAndTail<T>)ref).setTail(newnode);
		return newnode;
	}
	@Override
	public void remove(HeadAndTail<T> ref) {
		setValue(prev.getValue());
		link((HeadOrMiddleNode<T>)prev.getPrev(), this);
	}
	//
	public void setPrev(HeadOrMiddleNode<T> prev) {
		this.prev = prev;
	}
}
